package PluS;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class Component {
	String ID;
	String library;
	String pluginHost;
	String extensionPt;
	String pluginClass;
	Plugin plugin;
	List<String> ePoints;
	List<String> dependencies;
	
	public Component(String pluginID, String lib, String pClass, String hostID, String extensionpointID, List<String> extPoints, List<String> deps){
		ID = pluginID;
		library = lib;
		pluginHost = hostID;
		extensionPt = extensionpointID;
		ePoints = extPoints;
		pluginClass = pClass;
		
	}

	public void registerWith(PluginLoader loader) {
		boolean success = loader.addJarToClasspath(library);
		if(success) loader.register(ID, this);
	}

	public List<String> getDependencies() {
		List<String> result = new ArrayList<String>(dependencies);
		result.add(pluginHost);
		return result;
	}

	public void instantiate() {
		// TODO Auto-generated method stub
		try {
			Object pluginObj = Class.forName(pluginClass).newInstance();
			plugin = (Plugin) pluginObj;
		} catch (InstantiationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public String getHostID() {
		return pluginHost;
	}

	public void addSelf(Map<String, Component> linked) {
		linked.put(ID, this);
	}

	public void registerAsExtension(Component host) {
		host.registerExtension(extensionPt, plugin);
	}

	public void registerExtension(String extPtID, Plugin p) {
		// TODO Auto-generated method stub
		plugin.registerExtension(extPtID, p);
	}

}
