package PluS;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

public class PluginLinker {

	public void link(Map<String, Component> components) {
		Map<String, Component> unlinked = new HashMap<String, Component>(components);
		Map<String, Component> linked = new HashMap<String, Component>();
		
		//Currently, this won't work :(
		//TODO:actually create a PluS component somewhere
		Component plus = unlinked.get("PluS");
		plus.instantiate();
		linked.put("PluS", plus);
		unlinked.remove("PluS");
		
		//The rest should be fine, if rather inefficient...
		while(unlinked.size()>0){
			Iterator<Component> cIter = unlinked.values().iterator();
			while(cIter.hasNext()){
				Component c = cIter.next();
				Component host = linked.get(c.getHostID());
				if(host!=null){
					c.registerAsExtension(host);
					c.addSelf(linked);
					cIter.remove();
				}
			}
		}
	}

}
